
#property indicator_separate_window

#property indicator_buffers 3

#property indicator_minimum 0
#property indicator_maximum 100

#property indicator_color1  Yellow
#property indicator_color2  Lime
#property indicator_color3  Red
#property indicator_width2 2
#property indicator_width3 2
extern int FastMA=12;
extern int SlowMA=24;
extern int Crosses=50;

// buffers
double Values[];           // values
double ExtremumsUp[];        // extremums
double ExtremumsDown[];        // extremums

int DigitsUsed = 5;
int EmptyValueUsed = 0;

int init()
{
IndicatorBuffers(3);
   SetIndexBuffer(0, Values);
   SetIndexBuffer(1, ExtremumsUp);
    SetIndexBuffer(2, ExtremumsDown);

   // buffers settings
   SetIndexStyle(0, DRAW_LINE);     // values are drawn as a solid line

   SetIndexStyle(1, DRAW_ARROW);    // extremums are drawn as circles
   SetIndexArrow(1, 159);
    SetIndexStyle(2, DRAW_ARROW);    // extremums are drawn as circles
   SetIndexArrow(2, 159);
   IndicatorDigits(DigitsUsed);
   
  

   return(0);
}

int start()
{
   int i, limit, counted_bars=IndicatorCounted();
   if (counted_bars == 0)  
    limit = Bars - counted_bars;
   if (counted_bars > 0)  
    limit = Bars - counted_bars;
  
 for ( i = limit; i >=0; i-- ) 
   {
      Values[i] = NormalizeDouble(iCustom(Symbol(),0,"Cycle_KROUFR_version",FastMA,SlowMA,Crosses ,0, i), DigitsUsed);
   }
      
 for ( i = limit; i >=0; i-- ) 
  
   {
      // to check the extremum we need at least 2 older bars
      // if they are not available, there is no reason to continue
      if (i + 2 >= Bars)
      {
         continue;
      }

      // check empty values
      if (
            Values[i]      == EmptyValueUsed || 
            Values[i + 1]  == EmptyValueUsed ||
            Values[i + 2]  == EmptyValueUsed
      )
      {
         continue;
      }
      
      // clean current mark
      ExtremumsUp[i + 1] = EMPTY_VALUE;
            ExtremumsDown[i + 1] = EMPTY_VALUE;

      // extremum condition -- simple case
      if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[i + 2]) < 0 && Values[i+1]<50 )
      {
         // if available
         ExtremumsUp[i + 1] = Values[i + 1];
         continue;
      }
       if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[i + 2]) < 0 && Values[i+1]>50 )
      {
         // if available
         ExtremumsDown[i + 1] = Values[i + 1];
         continue;
      }
      // extremum condition -- complicated case
      if (Values[i + 1] == Values[i + 2] && Values[i] != Values[i + 1])
      {
         // potential one is available

         int index = i + 2;
         bool found = false;
         while (index < Bars && Values[index] != EmptyValueUsed && Values[index] != EMPTY_VALUE)
         {
            if (Values[i + 2] != Values[index])
            {
               // got the end
               found = true;
               break;
            }
            
            index++;
         }

         if (!found)
         {
            // not got the end
            continue;
         }
         
         // test the extremum
         if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[index]) < 0 && Values[i+1]<50)
         {
            // got it
            ExtremumsUp[i + 1] = Values[i + 1];
         }  // got bending
        if ((Values[i] - Values[i + 1])*(Values[i + 1] - Values[index]) < 0 && Values[i+1]>50)
         {
            // got it
            ExtremumsDown[i + 1] = Values[i + 1];
         }  // got bending 
      }
   }
   
   return(0);
}